#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;
const int N = 1e5 + 50;
char s[N][12];
struct rec
{
    int s, p, t;
    OPL(rec, rhs)
    {
        return p > rhs.p || (p == rhs.p && t < rhs.t);
    }
} recs[N];
int main()
{
    int T, n, d;
    scanf("%d", &T);
    while (T--)
    {
        scanf("%d%d", &n, &d);
        for (int i = 0; i < n; i++)
            scanf("%s%d%d", s + i, &recs[i].p, &recs[i].t), recs[i].s = i;
        sort(recs, recs + n);
        if (n * d % 10 == 5)
            puts(s[recs[n * d / 10].s]);
        else
            puts("Quailty is very great");
    }
    return 0;
}